import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.sql.Types;

import quadbase.reportdesigner.ReportAPI.DBInfo;
import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.ColInfo;
import quadbase.reportdesigner.util.SimpleQueryFileInfo;
import quadbase.reportdesigner.util.SimpleQueryInParam;

public class DrillDown extends Applet {
	static final long serialVersionUID = 1;

	public static void main(java.lang.String[] args) {

		try {

			DrillDown doReport = new DrillDown();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", doReport.doDrillDownReport(frame));
			frame.setSize(900, 800);
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setVisible(true);

		} catch (Exception ex) {

			ex.printStackTrace();

		}

	}

	@Override
	public void init() {

		setLayout(new BorderLayout());
		add("Center", doDrillDownReport(this));

	}

	Component doDrillDownReport(Object parent) {
		QbReport.setEspressManagerUsed(false);

		//		Begin Code : Creating Report 1  - the Root Report
		DBInfo rootInfo = new DBInfo("jdbc:hsqldb:woodview",
				"org.hsqldb.jdbcDriver",
				"sa",
				"",
				"select Categories.CategoryName, sum(Products.UnitsInStock) " +
						"from Categories, Products " +
						"where Categories.CategoryID = Products.CategoryID " +
						"group by Categories.CategoryName " +
						"order by Categories.CategoryName;"
				);

		ColInfo rootColInfo[] = new ColInfo[2];
		for (int i = 0; i < rootColInfo.length; i++) {
			rootColInfo[i] = new ColInfo(i);
		}

		rootColInfo[0].setName("Product Name");
		rootColInfo[1].setName("Total Units In Stock");
		QbReport rootReport = new QbReport(
				parent,
				QbReport.COLUMNAR,
				rootInfo,
				rootColInfo,
				"DrillDown.rpt");
		//		End Code : Creating Report 1  - the Root Report
		//		Begin Code : Creating Report 2  - the drill down Report
		SimpleQueryInParam inParam = new SimpleQueryInParam("param", "Please select", true,
				"Categories", "CategoryName", Types.VARCHAR, "Arm Chairs", null);

		SimpleQueryInParam[] paramSet = { inParam };
		SimpleQueryFileInfo levelOneReportInfo = new SimpleQueryFileInfo(
				"jdbc:hsqldb:woodview",
				"org.hsqldb.jdbcDriver",
				"sa",
				"",
				"select Categories.CategoryName, Products.ProductName, Products.UnitPrice, Products.UnitsInStock from Categories, Products where Categories.CategoryID=Products.CategoryID and Categories.CategoryName=:param order by Categories.CategoryName, Products.ProductName;");
		levelOneReportInfo.setInParam(paramSet);
		ColInfo levelOneReportColInfo[] = new ColInfo[4];
		for (int i = 0; i < levelOneReportColInfo.length; i++) {
			levelOneReportColInfo[i] = new ColInfo(i);
		}

		levelOneReportColInfo[0].setName("Product Type");
		levelOneReportColInfo[1].setName("Product Name");
		levelOneReportColInfo[2].setName("Price");
		levelOneReportColInfo[3].setName("Units In Stock");

		try {
			//			createDrillDownReport(Name, Type of Report, database information, column mapping, template, column of root report to be mapped to)
			rootReport.createDrillDownReport("TestDrillDownReport",
					QbReport.COLUMNAR,
					levelOneReportInfo,
					levelOneReportColInfo,
					"lvl1.rpt", new int[] { 0 });
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		rootReport.getTable().getColumn(0).setDrillDownName("TestDrillDownReport");
		//		End Code : Creating Report 2  - the drill down Report
		return (new Viewer().getComponent(rootReport));

	}

}
